VisualThemes:RegisterAddOnFunc("Baggins", function(self, first)
	--hook the CreateBagFrame method to catch when new bags are created
	self:Hook(Baggins, "CreateBagFrame", function(obj, bagid, ...)
		self.hooks[obj].CreateBagFrame(obj, bagid, ...)
		--following the original functions lead
		if not bagid then
			return
		end

		local bag = _G["BagginsBag"..bagid] --see if the bag was created
		if bag and not self:IsThemed(bag) then --if so, and it's not somehow themed already
			self:Theme(bag, 0) --attempt to theme it
			if self:IsThemed(bag) then --if successful lets deal with layout changes
				self:HookScript(bag, "OnHide", function(frame, ...) --when the bag fully hides tell baggins to update the layout
					self.hooks[frame].OnHide(frame, ...)
					obj:UpdateLayout()
					if BagginsSearch then --if Baggins_Search is in use then tell it to hide it's search pane (if needed) when this hides
						BagginsSearch:UpdateEditBoxPosition()
					end
				end)
				
			end
		end
		
	end)
end)